<?
error_reporting(E_ALL);
define('SECOND_PER_DAY',(60*60*24));
function printr($data){print '<pre>';print_r($data);print'</pre>';}
function YYYYMMDDSTRING2time($date)
{
	$YYYY = substr($date,0,4);
	$MM = substr($date,4,2);
	$DD = substr($date,6,2);
	return mktime(0,0,0,$MM,$DD,$YYYY);
}
class RSSArray
{
	var $array;
	function RSSArray($filename){$this->read($filename);require_once "magpierss-0.72/rss_fetch.inc";}
	function read($filename)
	{
		$this->array = array();
		$buf = file($filename);
		foreach($buf as $cur){array_push($this->array,trim($cur));}
	}
	function printArray()
	{
		define('MAGPIE_INPUT_ENCODING', 'UTF-8');
		define('MAGPIE_OUTPUT_ENCODING', 'UTF-8');
		foreach($this->array as $cur)
		{
			$rss = fetch_rss($cur);
			print "<label class='array_title' onclick='layer_toggle(\"rss_{$cur[0]}\")'>{$rss->channel['title']}</label><br />";
			print "<div id='rss_{$cur[0]}' style='display:none'><ul>";
			foreach ($rss->items as $item )
			{
				//echo "<a href={$item['link']}>{$item['title']}</a> - {$item['summary']}</li><br>
				echo "<a href={$item['link']}>{$item['title']}</a></li><br>
					";
			}
			print '</ul></div>';
		}
	}
}
class DateArray
{
	var $array;
	var $viewPast = false;
	function DateArray($filename){$this->read($filename);}
	function setViewPast($flag){$this->viewPast = $flag;}
	function read($filename)
	{
		$this->array = array();
		$buf = file($filename);
		foreach($buf as $cur){array_push($this->array,split("\t",$cur));}
	}
	function printArray()
	{
		$cal_data = array();
		$now = YYYYMMDDSTRING2time(date("Ymd"));
		$startTime = $now;
		$endTime = $now;
		ob_start();
		print "<label class='array_title' onclick='layer_toggle(\"dateArray\")'>Date</label><br />";
		print '<div id="dateArray" style="display:none"><ul>';
		foreach($this->array as $cur)
		{
			if(1 != strlen($cur[0])){continue;}
			$target = YYYYMMDDSTRING2time($cur[1]);

			$d_day = ($target - $now) / (60*60*24);
			if(($target - $now) > 0){$d_day = "-".($d_day);}
			else if(($target - $now) <0)
			{
				if(false == $this->viewPast){continue;}
				$d_day = "+".(0-$d_day+1);
			}
			else{$d_day = "TODAY";}
			$cur[2] = trim($cur[2]);
			print "<li>{$cur[1]} [{$d_day}] {$cur[2]}</li>\n";
			if(false == isset($cal_data[$target]))
			{
				$cal_data[$target]['print'] = true;
				$cal_data[$target]['string'] = array();
			}
			array_push($cal_data[$target]['string'],$cur[2]);
			if($startTime > $target){$startTime = $target;}
			if($endTime < $target){$endTime = $target;}
		}
		print '</ul></div>';
		$result_list = ob_get_contents();
		ob_end_clean();
		ob_start();
		print "<label class='array_title' onclick='layer_toggle(\"dateCal\")'>Cal</label><br />";
		print '<div id="dateCal" style="display:block">';
		print_calendar(time2YYYYMMDDSTRING2($startTime),time2YYYYMMDDSTRING2($endTime),$cal_data);
		print '</div>';
		$result_cal = ob_get_contents();
		ob_end_clean();
		print $result_list.$result_cal;
	}
}
class LinkArray
{
	var $array;
	function LinkArray($filename){$this->read($filename);}
	function read($filename)
	{
		$this->array = array();
		$buf = file($filename);
		foreach($buf as $cur){array_push($this->array,split("\t",$cur));}
	}
	function printArray()
	{
		$opened = false;
		foreach($this->array as $cur)
		{
			if('G' == $cur[0][0])
			{
				$cur[1] = trim($cur[1]);
				if($opened){print '</ul></div>';}
				print "<label class='array_title' onclick='layer_toggle(\"{$cur[1]}\")'>{$cur[1]}</label><br />";
				if(2 == strlen($cur[0])){$display = 'block';}
				else{$display = 'none';}
				print "<div id='{$cur[1]}' style='display:{$display}'><ul>";
				$opened = true;
			}
			else if('L' == $cur[0][0])
			{
				$cur[2] = trim($cur[2]);
				print "<li><a href='{$cur[2]}'>{$cur[1]}</a></li>\n";
			}
		}
		if(true == $opened){print '</ul></div>';}
	}
}
function scandir($dirname)
{
	$files = array();
	$dh  = opendir($dirname);
	while (false !== ($filename = readdir($dh))){array_push($files,$filename);}
	sort($files);
	return $files;
}
class DirectoryArray
{
	var $array;
	function DirectoryArray($dirname_array){$this->read($dirname_array);}
	function read($dirname_array)
	{
		$this->array = array();
		foreach($dirname_array as $cur)
		{
			$dir = array();
			$dir['file'] = scandir($cur);
			$dir['dirname'] = $cur;
			array_push($this->array,$dir);
		}
	}
	function printArray()
	{
		foreach($this->array as $cur)
		{
			print "<label class='array_title' onclick='layer_toggle(\"{$cur['dirname']}\")'>{$cur['dirname']}</label><br />";
			print "<div id='{$cur['dirname']}' style='display:none'><ul>";
			foreach($cur['file'] as $cur_file)
			{
				if('.' == $cur_file[0]){continue;}
				print "<li><a href='./{$cur['dirname']}/{$cur_file}'>{$cur_file}</a></li>\n";
			}
			print '</ul></div>';
		}
	}
}
function time2YYYYMMDDSTRING2($YYYYMMDD){return date("Ymd",$YYYYMMDD);}
function FirstTimeOfWeek($time){return $time - date("w",$time) * SECOND_PER_DAY;}
function isSunday($time){return 0 == date("w",$time);}
function isSaturday($time){return 6 == date("w",$time);}
function getMonthOfTime($time){return date("m",$time);}
function getDayOfTime($time){return date("d",$time);}
function print_calendar($startDay,$endDay,$data)
{
	$option['hover'] = 'onmouseover="style.backgroundColor=\'#CCC\'" onmouseout="style.backgroundColor=\'#FFFFFF\'"';
	$startTime = YYYYMMDDSTRING2time($startDay);
	$endTime = YYYYMMDDSTRING2time($endDay);
	$todayTime = YYYYMMDDSTRING2time(date("Ymd"));

	$startWeekTime = FirstTimeOfWeek($startTime);
	$endWeekTime = FirstTimeOfWeek($endTime);
	print '<table class="lacoCalendar"><tr class="lacoCalendar_th"><td>일</td><td>월</td><td>화</td><td>수</td><td>목</td><td>금</td><td>토</td></tr>';
	$cur_month = getMonthOfTime($startWeekTime);
	for($i=$startWeekTime;$i<$endWeekTime + 7*SECOND_PER_DAY;$i=$i+=SECOND_PER_DAY)
	{
		$cur_day = getDayOfTime($i);
		$new_month = getMonthOfTime($i);
		$opt_month = '';
		if($cur_month != $new_month)
		{
			$cur_month = $new_month;
			$opt_month = "<span class='new_month'>{$cur_month}월</span><br />";
		}
		$opt_today = '';
		if($i == $todayTime)
		{
			$opt_today = '<br /><span class="today">오늘</span>';
		}

		$opt_class = '';
		if(true == isSunday($i))
		{
			print "<tr class='lacoCalendar_tr' {$option['hover']}>";
			$opt_class = 'lacoCalendar_td_sunday';
		}
		if($i == $todayTime){$opt_class = $opt_class.' today';}
		$string_day = "";
		if(isset($data[$i]))
		{
			$opt_class = $opt_class.' exist';
			foreach($data[$i]['string'] as $cur)
			{
				$string_day = $string_day."<label title='{$cur}'>~</label>";

			}
		}
		if(!empty($string_day)){$string_day = '<br />'.$string_day;}
		print "<td class='lacoCalendar_td {$opt_class}'>{$opt_month}{$cur_day}{$string_day}{$opt_today}</td>";
		if(true == isSaturday($i)){print '</tr>';}
	}
	print '</table>';
}
?>
